import java.util.LinkedList;

public class MyIPAddrMerge {
	LinkedList<String> addrList = null;
	int addrLengthBeforeMerge = 0;
	int addrLengthAfterMerge = 0;

	public MyIPAddrMerge(LinkedList<String> addrList) {
		this.addrList = addrList;
	}
	public double deaggregationRate()
	{
		return (1.0*addrLengthBeforeMerge-addrLengthAfterMerge)/addrLengthAfterMerge;
	}
	public void doOverAllIPMerge() {
		if (addrList == null)
			return;
		addrLengthBeforeMerge = addrList.size();
//		if(addrLengthBeforeMerge==1) {
//			addrLengthAfterMerge = 1;
//			return;
//		}
		boolean isFinished = false;
		while (!isFinished) {
			int listLength = addrList.size();
			label1:
			for(int i=0; i<listLength-1; i++) {
				for(int j=i+1; j<listLength; j++)
				{
					String merge = doIPmerge(addrList.get(i),addrList.get(j));
					if(merge != null) {
						addrList.remove(j);
						addrList.remove(i);
						addrList.add(merge);
						break label1;
					}
				}
			}
			if(listLength==addrList.size()){
				isFinished = true;
				addrLengthAfterMerge=listLength;
			}
		}
	}

	public String doIPmerge(String addr1, String addr2) {
		if (addr1 == "" || addr2 == ""){
			System.err.print("null ip address error!!!");
			System.exit(0);
		}
		String[] list1=addr1.split("/");
		String[] list2=addr2.split("/");
		String ip1=toBinaryIPAddr(list1[0]);
		String ip2=toBinaryIPAddr(list2[0]);
		int maskLen1 = Integer.parseInt(list1[1]);
		int maskLen2 = Integer.parseInt(list2[1]);
		String result = null;
		if(maskLen1==maskLen2) {
			String tmp1 = ip1.substring(0, maskLen1-1);
			String tmp2 = ip2.substring(0, maskLen2-1);
			if(tmp1.equals(tmp2))
			{
				for(int i=0;i<33-maskLen1;i++)
				{
					tmp1 += "0";
				}
				String tmpIP = toNormalIPAddr(tmp1);
				result = tmpIP+"/"+(maskLen1-1);
			}
		}else if(maskLen1<maskLen2) {
			String tmp1 = ip1.substring(0, maskLen1);
			String tmp2 = ip2.substring(0, maskLen1);
			if(tmp1.equals(tmp2))
				result = addr1;
		}else if(maskLen2<maskLen1) {
			String tmp1 = ip1.substring(0, maskLen2);
			String tmp2 = ip2.substring(0, maskLen2);
			if(tmp1.equals(tmp2))
				result = addr2;
		}
		return result;
	}
	public String toBinaryIPAddr(String ipAddr)
	{
		String[] list = ipAddr.split("\\.");
		if(list.length!=4){
			System.out.println(ipAddr);
			System.err.print("ip address segment is wrong!!!");
			System.exit(0);
		}
		String result = "";
		for(int i=0; i<4; i++){
			int tmp = Integer.parseInt(list[i]);
			String stmp = Integer.toBinaryString(tmp);
			int len = stmp.length();
			if(len<8)
			{
				for(int j=0;j<(8-len);j++)
				{
					stmp="0"+stmp;
				}
			}
			result += stmp;
		}
		return result;
	}
	public String toNormalIPAddr(String ipAddr) {
		if(ipAddr.length()!=32){
			System.err.print("ip address length is wrong!!!");
			System.exit(0);
		}
		String result = "";
		for(int i=0;i<4;i++){
			String tmp=ipAddr.substring(8*i, 8*(i+1));
			int itmp = Integer.parseInt(tmp, 2);
			result += String.valueOf(itmp);
			if(i!=3)
				result += ".";
		}
		return result;
	}
}
