import java.io.*;
import java.util.Date;
import gmu.cnl.*;
public class RouTabParse {
	private String rTabName;
	// Scanner scanner = null;
	BufferedReader br;
	LinkSimpleAS totalASList = null;

	// constructor
	RouTabParse(String name) {
		rTabName = name;
		br = null;
		totalASList = null;
	}

	private void log(String aMessage) {
		System.out.println(aMessage);
	}

	boolean init() {
		try {
			totalASList = new LinkSimpleAS();
			FileReader fr = new FileReader(rTabName);
			br = new BufferedReader(fr);
			// scanner = new Scanner(new File(rTabName));
			return true;
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}

	}

	void parseline(String text) {
		String[] list = text.split(" ");
		text = null;
		int length = list.length;
		SimpleAS simpleAS = null;
		int as=0; //use to eliminate AS path prepending
		int position=0;
		try {
			as=Integer.parseInt(list[length - 1]);
			simpleAS = new SimpleAS(as);
			list[length - 1] = null;
			position++;
			simpleAS.addPosition(position);
			simpleAS.addAddr(list[0].trim());
			totalASList.insert(simpleAS);
		} catch (Exception e) {
			System.out.println(list[length - 1]);
		}
		int i=2;
		boolean isASprepended = false;
		while(i < length) {
			try {
				int tmp=Integer.parseInt(list[length - i]);
				list[length - i] = null;
				if(as==tmp){
					isASprepended = true;
					i++;
					continue;
				}
				else{
					as=tmp;
					i++;
					simpleAS.setASPathPrepended(isASprepended);
					simpleAS = new SimpleAS(as);
					position++;
					simpleAS.addPosition(position);
					isASprepended = false;
				totalASList.insert(simpleAS);
				}
			} catch (Exception e) {
				System.out.println(list[length - i]);
			}
		}
		list = null;
	}

	void read() throws IOException {
		log("Reading from file.");
		int cout = 0;
		// Scanner scanner = new Scanner(new File(rTabName));
		try {
			String text = br.readLine();
			while (text != null) {
				parseline(text.trim());
				text = br.readLine();
				cout++;
			}
		} finally {
			System.out.println("The total lines of routing table: "+cout);
			br.close();
		}
	}

	public static void main(String[] args) throws IOException {

		System.out.println((new Date()));
		//String filename = "/Users/yan/Downloads/oix-full-snapshot-2010-08-25-1400.clean";
		RouTabParse rtParse = new RouTabParse(args[0]);
		rtParse.init();
		try {
			rtParse.read();
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.gc();
		SimpleAS current = rtParse.totalASList.first;
		while(current!=null) {
			current.findLevel();
			current = current.next;
		}
		FileOutputStream f_out = new FileOutputStream(args[0]+".total");
		ObjectOutputStream obj_out = new ObjectOutputStream(f_out);
		rtParse.totalASList.writeExternal(obj_out);
		obj_out.flush();
		obj_out.close();
		f_out.close();
		// rtParse.head.printAll();
	}

}
