clear;clc
%unix('ls IPdeaggregation/*.edge>filelist.ip.edge');
%unix('ls IPdeaggregation/*.tran>filelist.ip.tran');
NN=12;
fid1 = fopen('filelist.ip.edge','r');
fid2 = fopen('filelist.ip.tran','r');
edgeOriRow = zeros(1,NN);
edgeRow = zeros(1,NN);
edgeDE = zeros(1,NN);
tranOriRow = zeros(1,NN);
tranRow = zeros(1,NN);
tranDE = zeros(1,NN);
for i=1:NN
    filename1 = fscanf(fid1, '%s', 1);
    filename2 = fscanf(fid2, '%s', 1);
    fidedge = fopen(filename1,'r');
    fidtran = fopen(filename2,'r');
    tmp1 = fscanf(fidedge,'%d %d %d %d %f',[5,inf])';
    tmp2 = fscanf(fidtran,'%d %d %d %d %f',[5,inf])';
    fclose(fidedge);
    fclose(fidtran);
    edgeOriRow(i) = size(tmp1,1);
    tranOriRow(i) = size(tmp2,1);
    j=1;
    while j<=size(tmp1,1)
        if tmp1(j,5)==0
            tmp1(j,:)=[];
        else
            j = j+1;
        end
    end
    j=1;
    while j<=size(tmp2,1)
        if tmp2(j,5)==0
            tmp2(j,:)=[];
        else
            j = j+1;
        end
    end
    edgeRow(i) = size(tmp1,1);
    tranRow(i) = size(tmp2,1);
    s1 = ['edge' num2str(i) '=tmp1;'];
    s2 = ['tran' num2str(i) '=tmp2;'];
    eval(s1);
    eval(s2); 
end
fclose(fid1);
fclose(fid2);
totalAS = edgeRow + tranRow;
edgeMin = min(edgeRow);
tranMin = min(tranRow);
N = 5;
edgeM = [   edge1(1:edgeMin,N) edge2(1:edgeMin,N) edge3(1:edgeMin,N)...
            edge4(1:edgeMin,N) edge5(1:edgeMin,N) edge6(1:edgeMin,N)... 
            edge7(1:edgeMin,N) edge8(1:edgeMin,N) edge9(1:edgeMin,N)... 
            edge10(1:edgeMin,N) edge11(1:edgeMin,N) edge12(1:edgeMin,N)
            ];
tranM = [   tran1(1:tranMin,N) tran2(1:tranMin,N) tran3(1:tranMin,N)...
            tran4(1:tranMin,N) tran5(1:tranMin,N) tran6(1:tranMin,N)... 
            tran7(1:tranMin,N) tran8(1:tranMin,N) tran9(1:tranMin,N)... 
            tran10(1:tranMin,N) tran11(1:tranMin,N) tran12(1:tranMin,N)
            ];
scrsz = get(0,'ScreenSize');
label = [ '09-01';
          '09-03';
          '09-05';
          '09-07';
          '09-09';
          '09-11';
          '10-01';
          '10-03';
          '10-05';
          '10-07';
          '10-09';
          '10-11'];
%--------------------------------------------
figure('Position',[1 scrsz(4)/2 768 307]);% 3*scrsz(3)/4 0.3*scrsz(3)]);
boxplot(edgeM,'whisker',inf)%'medianstyle','target');%,'whisker',100);
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('IP deaggregation rate');
xlabel('Time');
hold on
plot(1:12,median(edgeM,1),'*');
hold off
%------------------------------------------
figure('Position',[1 scrsz(4)/2 768 307]);% 3*scrsz(3)/4 0.3*scrsz(3)]);
boxplot(tranM,'whisker',inf);%,'whisker',100);
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('IP deaggregation rate');
xlabel('Time');
hold on
plot(1:12,median(tranM,1),'*');
hold off
%-------------------------------------------
figure('Position',[1 scrsz(4)/2 768 307]);% 3*scrsz(3)/4 0.3*scrsz(3)]);
plot(edgeRow./edgeOriRow, '-d');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('IP deaggregation probability');
xlabel('Time');
%-------------------------------------------
figure('Position',[1 scrsz(4)/2 768 307]);% 3*scrsz(3)/4 0.3*scrsz(3)]);
plot(tranRow./tranOriRow, '-d');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)
ylabel('IP deaggregation probability');
xlabel('Time');