clear;clc
%unix('ls ASBD/*.edge>filelist.edge');
%unix('ls ASBD/*.tran>filelist.tran');
NN=12;
fid1 = fopen('filelist.edge','r');
fid2 = fopen('filelist.tran','r');
edgeRow = zeros(1,NN);
edgePrepending = zeros(1,NN);
tranRow = zeros(1,NN);
tranPrepending = zeros(1,NN);
for i=1:NN
    filename1 = fscanf(fid1, '%s', 1);
    filename2 = fscanf(fid2, '%s', 1);
    fidedge = fopen(filename1,'r');
    fidtran = fopen(filename2,'r');
    s1 = ['edge' num2str(i) '=fscanf(fidedge,''%d %d %d %d %d %f'',[6,inf])'';'];
    s2 = ['tran' num2str(i) '=fscanf(fidtran,''%d %d %d %d %d %f'',[6,inf])'';'];
    eval(s1);
    eval(s2);
    fclose(fidedge);
    fclose(fidtran);
    edgeRow(i) = eval(['size(edge' num2str(i) ',1)']);
    tranRow(i) = eval(['size(tran' num2str(i) ',1)']);
    edgePrepending(i) = eval(['sum(edge' num2str(i) '(:,4))']);
    tranPrepending(i) = eval(['sum(tran' num2str(i) '(:,4))']);
end
totalAS = edgeRow + tranRow;

scrsz = get(0,'ScreenSize');
label = [ '09-01';
          '09-03';
          '09-05';
          '09-07';
          '09-09';
          '09-11';
          '10-01';
          '10-03';
          '10-05';
          '10-07';
          '10-09';
          '10-11'];

figure('Position',[1 scrsz(4)/2 768 307]);%3*scrsz(3)/4 0.3*scrsz(3)]);
subplot(2,1,1)
plot(edgePrepending./edgeRow, '-d');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)

ylabel('Path prepending probability');
xlabel('Time');
%figure('Position',[1 scrsz(4)/2 768 307]);%3*scrsz(3)/4 0.3*scrsz(3)]);
subplot(2,1,2)
plot(tranPrepending./tranRow, '-d');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)

ylabel('Path prepending probability');
xlabel('Time');

figure('Position',[1 scrsz(4)/2 768 307]);%3*scrsz(3)/4 0.3*scrsz(3)]);
plot(totalAS,'*');
% because each bin is .5 data units wide.
set(gca,'XLim',[.5 12.5]);% This automatically sets the
                         % XLimMode to manual.
set(gca,'XTick',[1:12])  % This automatically sets 
                         % the XTickMode to manual.

set(gca,'XTickLabel',label)

ylabel('Total number of ASes');
xlabel('Time');
